Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::RSA_PrivateKey Class Referencefinal abstract

`#include <rsa.h>`

Inheritance diagram for Botan::RSA_PrivateKey:

## Public Member Functions
virtual std::string | algo_name () const =0
std::string | algo_name () const override
virtual AlgorithmIdentifier | algorithm_identifier () const =0
AlgorithmIdentifier | algorithm_identifier () const override
bool | check_key (RandomNumberGenerator &rng, bool) const override
std::unique_ptr< PK_Ops::Decryption > | create_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
virtual std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
std::unique_ptr< PK_Ops::KEM_Decryption > | create_kem_decryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
virtual std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
virtual std::unique_ptr< PK_Ops::Key_Agreement > | create_key_agreement_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::Signature > | create_signature_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
virtual std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const override
virtual Signature_Format | default_x509_signature_format () const
virtual size_t | estimated_strength () const =0
size_t | estimated_strength () const override
std::string | fingerprint (const std::string &alg) const
std::string | fingerprint_private (const std::string &alg) const
std::string | fingerprint_public (const std::string &alg="SHA-256") const
const BigInt & | get_c () const
const BigInt & | get_d () const
const BigInt & | get_d1 () const
const BigInt & | get_d2 () const
const BigInt & | get_e () const
const BigInt & | get_n () const
virtual OID | get_oid () const
const BigInt & | get_p () const
const BigInt & | get_q () const
virtual size_t | key_length () const =0
size_t | key_length () const override
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
virtual AlgorithmIdentifier | pkcs8_algorithm_identifier () const
std::shared_ptr< const RSA_Private_Data > | private_data () const
secure_vector< uint8_t > | private_key_bits () const override
secure_vector< uint8_t > | private_key_info () const
std::shared_ptr< const RSA_Public_Data > | public_data () const
virtual std::vector< uint8_t > | public_key_bits () const =0
std::vector< uint8_t > | public_key_bits () const override
| RSA_PrivateKey (const AlgorithmIdentifier &alg_id, const secure_vector< uint8_t > &key_bits)
| RSA_PrivateKey (const BigInt &p, const BigInt &q, const BigInt &e, const BigInt &d=0, const BigInt &n=0)
| RSA_PrivateKey (RandomNumberGenerator &rng, size_t bits, size_t exp=65537)
virtual bool | stateful_operation () const
std::vector< uint8_t > | subject_public_key () const

## Protected Member Functions
void | init (BigInt &&n, BigInt &&e)

## Protected Attributes
std::shared_ptr< const RSA_Public_Data > | m_public

## Detailed Description

RSA Private Key

Definition at line 92 of file rsa.h.

## Constructor & Destructor Documentation

## ◆ RSA_PrivateKey() [1/3]

Botan::RSA_PrivateKey::RSA_PrivateKey | ( | const AlgorithmIdentifier & | alg_id,
|  | const secure_vector< uint8_t > & | key_bits
| ) |  |

Load a private key.

Parameters

  alg_id | the X.509 algorithm identifier
  key_bits | PKCS#1 RSAPrivateKey bits

Definition at line 207 of file rsa.cpp.

209 {
210 BigInt n, e, d, p, q, d1, d2, c;
211
212 BER_Decoder(key_bits)
213 .start_cons(SEQUENCE)
214 .decode_and_check<size_t>(0, "Unknown PKCS #1 key format version")
215 .decode(n)
216 .decode(e)
217 .decode(d)
218 .decode(p)
219 .decode(q)
220 .decode(d1)
221 .decode(d2)
222 .decode(c)
223 .end_cons();
224
225 RSA_PublicKey::init(std::move(n), std::move(e));
226
227 RSA_PrivateKey::init(std::move(d), std::move(p), std::move(q),
228 std::move(d1), std::move(d2), std::move(c));
229 }
Botan::RSA_PublicKey::init
void init(BigInt &&n, BigInt &&e)
Definition: rsa.cpp:107
Botan::PEM_Code::decode
secure_vector< uint8_t > decode(DataSource &source, std::string &label)
Definition: pem.cpp:68
Botan::SEQUENCE
@ SEQUENCE
Definition: asn1_obj.h:42

References Botan::PEM_Code::decode(), Botan::BER_Decoder::decode_and_check(), Botan::RSA_PublicKey::init(), Botan::SEQUENCE, and Botan::BER_Decoder::start_cons().

## ◆ RSA_PrivateKey() [2/3]

Botan::RSA_PrivateKey::RSA_PrivateKey | ( | const BigInt & | p,
|  | const BigInt & | q,
|  | const BigInt & | e,
|  | const BigInt & | d = `0`,
|  | const BigInt & | n = `0`
| ) |  |

Construct a private key from the specified parameters.

Parameters

  p | the first prime
  q | the second prime
  e | the exponent
  d | if specified, this has to be d with exp * d = 1 mod (p - 1, q - 1). Leave it as 0 if you wish to the constructor to calculate it.
  n | if specified, this must be n = p * q. Leave it as 0 if you wish to the constructor to calculate it.

Definition at line 231 of file rsa.cpp.

236 {
237 BigInt p = prime1;
238 BigInt q = prime2;
239 BigInt n = mod;
240 if(n.is_zero())
241 n = p * q;
242
243 BigInt e = exp;
244
245 BigInt d = d_exp;
246
247 const BigInt p_minus_1 = p - 1;
248 const BigInt q_minus_1 = q - 1;
249
250 if(d.is_zero())
251 {
252 const BigInt phi_n = lcm(p_minus_1, q_minus_1);
253 d = inverse_mod(e, phi_n);
254 }
255
256 BigInt d1 = ct_modulo(d, p_minus_1);
257 BigInt d2 = ct_modulo(d, q_minus_1);
258 BigInt c = inverse_mod(q, p);
259
260 RSA_PublicKey::init(std::move(n), std::move(e));
261
262 RSA_PrivateKey::init(std::move(d), std::move(p), std::move(q),
263 std::move(d1), std::move(d2), std::move(c));
264 }
Botan::lcm
BigInt lcm(const BigInt &a, const BigInt &b)
Definition: numthry.cpp:133
Botan::inverse_mod
BigInt inverse_mod(const BigInt &n, const BigInt &mod)
Definition: mod_inv.cpp:250
Botan::ct_modulo
BigInt ct_modulo(const BigInt &x, const BigInt &y)
Definition: divide.cpp:118

References Botan::ct_modulo(), Botan::RSA_PublicKey::init(), Botan::inverse_mod(), Botan::BigInt::is_zero(), and Botan::lcm().

## ◆ RSA_PrivateKey() [3/3]

Botan::RSA_PrivateKey::RSA_PrivateKey | ( | RandomNumberGenerator & | rng,
|  | size_t | bits,
|  | size_t | exp = `65537`
| ) |  |

Create a new private key with the specified bit length

Parameters

  rng | the random number generator to use
  bits | the desired bit length of the private key
  exp | the public exponent to be used

Definition at line 269 of file rsa.cpp.

271 {
272 if(bits < 1024)
273 throw Invalid_Argument(algo_name() + ": Can't make a key that is only " +
274 std::to_string(bits) + " bits long");
275 if(exp < 3 || exp % 2 == 0)
276 throw Invalid_Argument(algo_name() + ": Invalid encryption exponent");
277
278 BigInt n, e, d, p, q, d1, d2, c;
279
280 e = exp;
281
282 const size_t p_bits = (bits + 1) / 2;
283 const size_t q_bits = bits - p_bits;
284
285 do
286 {
287 // TODO could generate primes in thread pool
288 p = generate_rsa_prime(rng, rng, p_bits, e);
289 q = generate_rsa_prime(rng, rng, q_bits, e);
290
291 if(p == q)
292 throw Internal_Error("RNG failure during RSA key generation");
293
294 n = p * q;
295 } while(n.bits() != bits);
296
297 const BigInt p_minus_1 = p - 1;
298 const BigInt q_minus_1 = q - 1;
299
300 const BigInt phi_n = lcm(p_minus_1, q_minus_1);
301 d = inverse_mod(e, phi_n);
302 d1 = ct_modulo(d, p_minus_1);
303 d2 = ct_modulo(d, q_minus_1);
304 c = inverse_mod(q, p);
305
306 RSA_PublicKey::init(std::move(n), std::move(e));
307
308 RSA_PrivateKey::init(std::move(d), std::move(p), std::move(q),
309 std::move(d1), std::move(d2), std::move(c));
310 }
Botan::RSA_PublicKey::algo_name
std::string algo_name() const override
Definition: rsa.h:43
Botan::ASN1::to_string
std::string to_string(const BER_Object &obj)
Definition: asn1_obj.cpp:213
Botan::OCSP::Response_Status_Code::Internal_Error
@ Internal_Error
Botan::generate_rsa_prime
BigInt generate_rsa_prime(RandomNumberGenerator &keygen_rng, RandomNumberGenerator &prime_test_rng, size_t bits, const BigInt &coprime, size_t prob)
Definition: make_prm.cpp:197

References Botan::RSA_PublicKey::algo_name(), Botan::BigInt::bits(), Botan::ct_modulo(), Botan::generate_rsa_prime(), Botan::RSA_PublicKey::init(), Botan::inverse_mod(), Botan::lcm(), and Botan::ASN1::to_string().

## Member Function Documentation

## ◆ algo_name() [1/2]

virtual std::string Botan::Public_Key::algo_name | ( |  | ) | const
| pure virtual inherited

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implemented in Botan::TPM_PrivateKey, Botan::Curve25519_PublicKey, Botan::DH_PublicKey, Botan::DSA_PublicKey, Botan::ECDH_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::Ed25519_PublicKey, Botan::ElGamal_PublicKey, Botan::GOST_3410_PublicKey, Botan::McEliece_PublicKey, Botan::RSA_PublicKey, Botan::SM2_PublicKey, Botan::XMSS_PublicKey, Botan::XMSS_WOTS_PublicKey, and Botan::XMSS_WOTS_Addressed_PublicKey.

Referenced by Botan::PKCS8::BER_encode(), botan_pubkey_sm2_compute_za(), Botan::TLS::Policy::check_peer_key_acceptable(), Botan::TLS::Handshake_State::choose_sig_format(), Botan::TLS::Client_Key_Exchange::Client_Key_Exchange(), Botan::EMSA1::config_for_x509(), Botan::EMSA_PKCS1v15::config_for_x509(), Botan::PSSR::config_for_x509(), Botan::Private_Key::create_decryption_op(), Botan::Public_Key::create_encryption_op(), Botan::Private_Key::create_kem_decryption_op(), Botan::Public_Key::create_kem_encryption_op(), Botan::Private_Key::create_key_agreement_op(), Botan::Private_Key::create_signature_op(), Botan::Public_Key::create_verification_op(), Botan::Public_Key::get_oid(), Botan::TLS::Handshake_State::parse_sig_format(), Botan::PK_Decryptor_EME::PK_Decryptor_EME(), Botan::PK_Encryptor_EME::PK_Encryptor_EME(), Botan::PK_KEM_Decryptor::PK_KEM_Decryptor(), Botan::PK_KEM_Encryptor::PK_KEM_Encryptor(), Botan::PK_Key_Agreement::PK_Key_Agreement(), Botan::PK_Signer::PK_Signer(), Botan::PK_Verifier::PK_Verifier(), Botan::verify_cert_constraints_valid_for_key_type(), and Botan::X509_Object::verify_signature().

## ◆ algo_name() [2/2]

std::string Botan::RSA_PublicKey::algo_name | ( |  | ) | const
| inline override virtual inherited

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 43 of file rsa.h.

43{ return "RSA"; }

Referenced by create_decryption_op(), Botan::RSA_PublicKey::create_encryption_op(), create_kem_decryption_op(), Botan::RSA_PublicKey::create_kem_encryption_op(), create_signature_op(), Botan::RSA_PublicKey::create_verification_op(), and RSA_PrivateKey().

## ◆ algorithm_identifier() [1/2]

virtual AlgorithmIdentifier Botan::Public_Key::algorithm_identifier | ( |  | ) | const
| pure virtual inherited

Returns
  X.509 AlgorithmIdentifier for this key

Implemented in Botan::TPM_PrivateKey, Botan::Curve25519_PublicKey, Botan::DL_Scheme_PublicKey, Botan::EC_PublicKey, Botan::Ed25519_PublicKey, Botan::GOST_3410_PublicKey, Botan::McEliece_PublicKey, Botan::RSA_PublicKey, Botan::XMSS_PublicKey, Botan::XMSS_WOTS_PublicKey, and Botan::XMSS_WOTS_Addressed_PublicKey.

Referenced by Botan::EMSA1::config_for_x509(), and Botan::Public_Key::subject_public_key().

## ◆ algorithm_identifier() [2/2]

AlgorithmIdentifier Botan::RSA_PublicKey::algorithm_identifier | ( |  | ) | const
| override virtual inherited

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 144 of file rsa.cpp.

145 {
146 return AlgorithmIdentifier(get_oid(), AlgorithmIdentifier::USE_NULL_PARAM);
147 }
Botan::AlgorithmIdentifier::USE_NULL_PARAM
@ USE_NULL_PARAM
Definition: asn1_obj.h:432
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:53

References Botan::Public_Key::get_oid(), and Botan::AlgorithmIdentifier::USE_NULL_PARAM.

## ◆ check_key()

bool Botan::RSA_PrivateKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| override virtual

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Reimplemented from Botan::RSA_PublicKey.

Definition at line 315 of file rsa.cpp.

316 {
317 if(get_n() < 35 || get_n().is_even() || get_e() < 3 || get_e().is_even())
318 return false;
319
320 if(get_d() < 2 || get_p() < 3 || get_q() < 3)
321 return false;
322
323 if(get_p() * get_q() != get_n())
324 return false;
325
326 if(get_p() == get_q())
327 return false;
328
329 if(get_d1() != ct_modulo(get_d(), get_p() - 1))
330 return false;
331 if(get_d2() != ct_modulo(get_d(), get_q() - 1))
332 return false;
333 if(get_c() != inverse_mod(get_q(), get_p()))
334 return false;
335
336 const size_t prob = (strong) ? 128 : 12;
337
338 if(!is_prime(get_p(), rng, prob))
339 return false;
340 if(!is_prime(get_q(), rng, prob))
341 return false;
342
343 if(strong)
344 {
345 if(ct_modulo(get_e() * get_d(), lcm(get_p() - 1, get_q() - 1)) != 1)
346 return false;
347
348 return KeyPair::signature_consistency_check(rng, *this, "EMSA4(SHA-256)");
349 }
350
351 return true;
352 }
Botan::RSA_PrivateKey::get_q
const BigInt & get_q() const
Definition: rsa.cpp:194
Botan::RSA_PrivateKey::get_c
const BigInt & get_c() const
Definition: rsa.cpp:196
Botan::RSA_PrivateKey::get_p
const BigInt & get_p() const
Definition: rsa.cpp:193
Botan::RSA_PrivateKey::get_d2
const BigInt & get_d2() const
Definition: rsa.cpp:198
Botan::RSA_PrivateKey::get_d
const BigInt & get_d() const
Definition: rsa.cpp:195
Botan::RSA_PrivateKey::get_d1
const BigInt & get_d1() const
Definition: rsa.cpp:197
Botan::RSA_PublicKey::get_n
const BigInt & get_n() const
Definition: rsa.cpp:104
Botan::RSA_PublicKey::get_e
const BigInt & get_e() const
Definition: rsa.cpp:105
Botan::KeyPair::signature_consistency_check
bool signature_consistency_check(RandomNumberGenerator &rng, const Private_Key &private_key, const Public_Key &public_key, const std::string &padding)
Definition: keypair.cpp:49
Botan::is_prime
bool is_prime(const BigInt &n, RandomNumberGenerator &rng, size_t prob, bool is_random)
Definition: numthry.cpp:218

References Botan::ct_modulo(), get_c(), get_d(), get_d1(), get_d2(), Botan::RSA_PublicKey::get_e(), Botan::RSA_PublicKey::get_n(), get_p(), get_q(), Botan::inverse_mod(), Botan::is_prime(), Botan::lcm(), and Botan::KeyPair::signature_consistency_check().

## ◆ create_decryption_op()

std::unique_ptr< PK_Ops::Decryption > Botan::RSA_PrivateKey::create_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Private_Key.

Definition at line 670 of file rsa.cpp.

673 {
674 if(provider == "base" || provider.empty())
675 return std::unique_ptr<PK_Ops::Decryption>(new RSA_Decryption_Operation(*this, params, rng));
676
677 throw Provider_Not_Found(algo_name(), provider);
678 }

References Botan::RSA_PublicKey::algo_name().

## ◆ create_encryption_op() [1/2]

std::unique_ptr< PK_Ops::Encryption > Botan::Public_Key::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::ElGamal_PublicKey, Botan::RSA_PublicKey, and Botan::SM2_PublicKey.

Definition at line 91 of file pk_keys.cpp.

94 {
95 throw Lookup_Error(algo_name() + " does not support encryption");
96 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Encryptor_EME::PK_Encryptor_EME().

## ◆ create_encryption_op() [2/2]

std::unique_ptr< PK_Ops::Encryption > Botan::RSA_PublicKey::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 640 of file rsa.cpp.

643 {
644 if(provider == "base" || provider.empty())
645 return std::unique_ptr<PK_Ops::Encryption>(new RSA_Encryption_Operation(*this, params));
646 throw Provider_Not_Found(algo_name(), provider);
647 }

References Botan::RSA_PublicKey::algo_name().

## ◆ create_kem_decryption_op()

std::unique_ptr< PK_Ops::KEM_Decryption > Botan::RSA_PrivateKey::create_kem_decryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM decryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Private_Key.

Definition at line 681 of file rsa.cpp.

684 {
685 if(provider == "base" || provider.empty())
686 return std::unique_ptr<PK_Ops::KEM_Decryption>(new RSA_KEM_Decryption_Operation(*this, params, rng));
687
688 throw Provider_Not_Found(algo_name(), provider);
689 }

References Botan::RSA_PublicKey::algo_name().

## ◆ create_kem_encryption_op() [1/2]

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::Public_Key::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::McEliece_PublicKey, and Botan::RSA_PublicKey.

Definition at line 99 of file pk_keys.cpp.

102 {
103 throw Lookup_Error(algo_name() + " does not support KEM encryption");
104 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Encryptor::PK_KEM_Encryptor().

## ◆ create_kem_encryption_op() [2/2]

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::RSA_PublicKey::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 650 of file rsa.cpp.

653 {
654 if(provider == "base" || provider.empty())
655 return std::unique_ptr<PK_Ops::KEM_Encryption>(new RSA_KEM_Encryption_Operation(*this, params));
656 throw Provider_Not_Found(algo_name(), provider);
657 }

References Botan::RSA_PublicKey::algo_name().

## ◆ create_key_agreement_op()

std::unique_ptr< PK_Ops::Key_Agreement > Botan::Private_Key::create_key_agreement_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a key agreement operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::Curve25519_PrivateKey, Botan::DH_PrivateKey, and Botan::ECDH_PrivateKey.

Definition at line 138 of file pk_keys.cpp.

141 {
142 throw Lookup_Error(algo_name() + " does not support key agreement");
143 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Key_Agreement::PK_Key_Agreement().

## ◆ create_signature_op()

std::unique_ptr< PK_Ops::Signature > Botan::RSA_PrivateKey::create_signature_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a signature operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Private_Key.

Definition at line 692 of file rsa.cpp.

695 {
696 if(provider == "base" || provider.empty())
697 return std::unique_ptr<PK_Ops::Signature>(new RSA_Signature_Operation(*this, params, rng));
698
699 throw Provider_Not_Found(algo_name(), provider);
700 }

References Botan::RSA_PublicKey::algo_name().

## ◆ create_verification_op() [1/2]

std::unique_ptr< PK_Ops::Verification > Botan::Public_Key::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::XMSS_PublicKey, Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::Ed25519_PublicKey, Botan::GOST_3410_PublicKey, Botan::RSA_PublicKey, Botan::SM2_PublicKey, and Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 107 of file pk_keys.cpp.

109 {
110 throw Lookup_Error(algo_name() + " does not support verification");
111 }

References Botan::Public_Key::algo_name().

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::create_verification_op(), and Botan::PK_Verifier::PK_Verifier().

## ◆ create_verification_op() [2/2]

std::unique_ptr< PK_Ops::Verification > Botan::RSA_PublicKey::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 660 of file rsa.cpp.

662 {
663 if(provider == "base" || provider.empty())
664 return std::unique_ptr<PK_Ops::Verification>(new RSA_Verify_Operation(*this, params));
665
666 throw Provider_Not_Found(algo_name(), provider);
667 }

References Botan::RSA_PublicKey::algo_name().

## ◆ default_x509_signature_format()

virtual Signature_Format Botan::Public_Key::default_x509_signature_format | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 125 of file pk_keys.h.

126 {
127 return (this->message_parts() >= 2) ? DER_SEQUENCE : IEEE_1363;
128 }
Botan::Public_Key::message_parts
virtual size_t message_parts() const
Definition: pk_keys.h:112
Botan::DER_SEQUENCE
@ DER_SEQUENCE
Definition: pk_keys.h:23
Botan::IEEE_1363
@ IEEE_1363
Definition: pk_keys.h:23

References Botan::DER_SEQUENCE, and Botan::IEEE_1363.

Referenced by Botan::X509_Object::choose_sig_format(), and Botan::X509_Object::verify_signature().

## ◆ estimated_strength() [1/2]

virtual size_t Botan::Public_Key::estimated_strength | ( |  | ) | const
| pure virtual inherited

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implemented in Botan::TPM_PrivateKey, Botan::Curve25519_PublicKey, Botan::DL_Scheme_PublicKey, Botan::EC_PublicKey, Botan::Ed25519_PublicKey, Botan::McEliece_PublicKey, Botan::RSA_PublicKey, Botan::XMSS_PublicKey, Botan::XMSS_WOTS_PublicKey, and Botan::XMSS_WOTS_Addressed_PublicKey.

Referenced by botan_pubkey_estimated_strength().

## ◆ estimated_strength() [2/2]

size_t Botan::RSA_PublicKey::estimated_strength | ( |  | ) | const
| override virtual inherited

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 139 of file rsa.cpp.

140 {
141 return if_work_factor(key_length());
142 }
Botan::RSA_PublicKey::key_length
size_t key_length() const override
Definition: rsa.cpp:134
Botan::if_work_factor
size_t if_work_factor(size_t bits)
Definition: workfactor.cpp:38

References Botan::if_work_factor(), and Botan::RSA_PublicKey::key_length().

## ◆ fingerprint()

std::string Botan::Private_Key::fingerprint | ( | const std::string & | alg | ) | const
| inline inherited

Definition at line 215 of file pk_keys.h.

216 {
217 return fingerprint_private(alg); // match behavior in previous versions
218 }
Botan::Private_Key::fingerprint_private
std::string fingerprint_private(const std::string &alg) const
Definition: pk_keys.cpp:85

## ◆ fingerprint_private()

std::string Botan::Private_Key::fingerprint_private | ( | const std::string & | alg | ) | const
| inherited

Returns
  Hash of the PKCS #8 encoding for this key object

Definition at line 85 of file pk_keys.cpp.

86 {
87 return create_hex_fingerprint(private_key_bits(), hash_algo);
88 }
Botan::Private_Key::private_key_bits
virtual secure_vector< uint8_t > private_key_bits() const =0
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22

References Botan::create_hex_fingerprint(), hash_algo, and Botan::Private_Key::private_key_bits().

Referenced by Botan::Certificate_Store_In_SQL::find_certs_for_key(), Botan::Certificate_Store_In_SQL::insert_key(), and Botan::Certificate_Store_In_SQL::remove_key().

## ◆ fingerprint_public()

std::string Botan::Public_Key::fingerprint_public | ( | const std::string & | alg = `"SHA-256"` | ) | const
| inherited

Returns
  Hash of the subject public key

Definition at line 77 of file pk_keys.cpp.

78 {
79 return create_hex_fingerprint(subject_public_key(), hash_algo);
80 }
Botan::Public_Key::subject_public_key
std::vector< uint8_t > subject_public_key() const
Definition: pk_keys.cpp:38

References Botan::create_hex_fingerprint(), hash_algo, and Botan::Public_Key::subject_public_key().

## ◆ get_c()

const BigInt & Botan::RSA_PrivateKey::get_c | ( |  | ) | const

Definition at line 196 of file rsa.cpp.

196{ return m_private->get_c(); }

Referenced by check_key(), and private_key_bits().

## ◆ get_d()

const BigInt & Botan::RSA_PrivateKey::get_d | ( |  | ) | const

Get d with exp * d = 1 mod (p - 1, q - 1).

Returns
  d

Definition at line 195 of file rsa.cpp.

195{ return m_private->get_d(); }

Referenced by check_key(), and private_key_bits().

## ◆ get_d1()

const BigInt & Botan::RSA_PrivateKey::get_d1 | ( |  | ) | const

Definition at line 197 of file rsa.cpp.

197{ return m_private->get_d1(); }

Referenced by check_key(), and private_key_bits().

## ◆ get_d2()

const BigInt & Botan::RSA_PrivateKey::get_d2 | ( |  | ) | const

Definition at line 198 of file rsa.cpp.

198{ return m_private->get_d2(); }

Referenced by check_key(), and private_key_bits().

## ◆ get_e()

const BigInt & Botan::RSA_PublicKey::get_e | ( |  | ) | const
| inherited

Returns
  public exponent

Definition at line 105 of file rsa.cpp.

105{ return m_public->get_e(); }
Botan::RSA_PublicKey::m_public
std::shared_ptr< const RSA_Public_Data > m_public
Definition: rsa.h:86

References Botan::RSA_PublicKey::m_public.

Referenced by Botan::RSA_PublicKey::check_key(), check_key(), private_key_bits(), and Botan::RSA_PublicKey::public_key_bits().

## ◆ get_n()

const BigInt & Botan::RSA_PublicKey::get_n | ( |  | ) | const
| inherited

Returns
  public modulus

Definition at line 104 of file rsa.cpp.

104{ return m_public->get_n(); }

References Botan::RSA_PublicKey::m_public.

Referenced by Botan::RSA_PublicKey::check_key(), check_key(), private_key_bits(), and Botan::RSA_PublicKey::public_key_bits().

## ◆ get_oid()

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 53 of file pk_keys.cpp.

54 {
55 const OID o = OIDS::str2oid_or_empty(algo_name());
56 if(o.empty())
57 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
58 return o;
59 }
Botan::OIDS::str2oid_or_empty
BOTAN_UNSTABLE_API OID str2oid_or_empty(const std::string &name)
Definition: oids.cpp:116

References Botan::Public_Key::algo_name(), Botan::OID::empty(), and Botan::OIDS::str2oid_or_empty().

Referenced by Botan::TPM_PrivateKey::algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::Ed25519_PublicKey::algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::McEliece_PublicKey::algorithm_identifier(), Botan::RSA_PublicKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

## ◆ get_p()

const BigInt & Botan::RSA_PrivateKey::get_p | ( |  | ) | const

Get the first prime p.

Returns
  prime p

Definition at line 193 of file rsa.cpp.

193{ return m_private->get_p(); }

Referenced by check_key(), and private_key_bits().

## ◆ get_q()

const BigInt & Botan::RSA_PrivateKey::get_q | ( |  | ) | const

Get the second prime q.

Returns
  prime q

Definition at line 194 of file rsa.cpp.

194{ return m_private->get_q(); }

Referenced by check_key(), and private_key_bits().

## ◆ init()

void Botan::RSA_PublicKey::init | ( | BigInt && | n,
|  | BigInt && | e
| ) |  |
| protected inherited

Definition at line 107 of file rsa.cpp.

108 {
109 if(n.is_negative() || n.is_even() || e.is_negative() || e.is_even())
110 throw Decoding_Error("Invalid RSA public key parameters");
111 m_public = std::make_shared<RSA_Public_Data>(std::move(n), std::move(e));
112 }

References Botan::RSA_PublicKey::m_public.

Referenced by RSA_PrivateKey(), and Botan::RSA_PublicKey::RSA_PublicKey().

## ◆ key_length() [1/2]

virtual size_t Botan::Public_Key::key_length | ( |  | ) | const
| pure virtual inherited

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implemented in Botan::TPM_PrivateKey, Botan::Curve25519_PublicKey, Botan::DL_Scheme_PublicKey, Botan::EC_PublicKey, Botan::Ed25519_PublicKey, Botan::McEliece_PublicKey, Botan::RSA_PublicKey, Botan::XMSS_PublicKey, Botan::XMSS_WOTS_PublicKey, and Botan::XMSS_WOTS_Addressed_PublicKey.

Referenced by Botan::TLS::Policy::check_peer_key_acceptable().

## ◆ key_length() [2/2]

size_t Botan::RSA_PublicKey::key_length | ( |  | ) | const
| override virtual inherited

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 134 of file rsa.cpp.

135 {
136 return m_public->public_modulus_bits();
137 }

References Botan::RSA_PublicKey::m_public.

Referenced by Botan::RSA_PublicKey::estimated_strength().

## ◆ message_part_size()

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 123 of file pk_keys.h.

123{ return 0; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ message_parts()

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 112 of file pk_keys.h.

112{ return 1; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ pkcs8_algorithm_identifier()

virtual AlgorithmIdentifier Botan::Private_Key::pkcs8_algorithm_identifier | ( |  | ) | const
| inline virtual inherited

Returns
  PKCS #8 AlgorithmIdentifier for this key Might be different from the X.509 identifier, but normally is not

Reimplemented in Botan::GOST_3410_PrivateKey, Botan::XMSS_WOTS_PrivateKey, and Botan::XMSS_WOTS_Addressed_PrivateKey.

Definition at line 204 of file pk_keys.h.

205 { return algorithm_identifier(); }
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0

Referenced by Botan::Private_Key::private_key_info().

## ◆ private_data()

std::shared_ptr< const RSA_Private_Data > Botan::RSA_PrivateKey::private_data | ( |  | ) | const

Definition at line 171 of file rsa.cpp.

172 {
173 return m_private;
174 }

## ◆ private_key_bits()

secure_vector< uint8_t > Botan::RSA_PrivateKey::private_key_bits | ( |  | ) | const
| override virtual

Returns
  BER encoded private key bits

Implements Botan::Private_Key.

Definition at line 176 of file rsa.cpp.

177 {
178 return DER_Encoder()
179 .start_cons(SEQUENCE)
180 .encode(static_cast<size_t>(0))
181 .encode(get_n())
182 .encode(get_e())
183 .encode(get_d())
184 .encode(get_p())
185 .encode(get_q())
186 .encode(get_d1())
187 .encode(get_d2())
188 .encode(get_c())
189 .end_cons()
190 .get_contents();
191 }

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), get_c(), Botan::DER_Encoder::get_contents(), get_d(), get_d1(), get_d2(), Botan::RSA_PublicKey::get_e(), Botan::RSA_PublicKey::get_n(), get_p(), get_q(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

## ◆ private_key_info()

secure_vector< uint8_t > Botan::Private_Key::private_key_info | ( |  | ) | const
| inherited

Returns
  PKCS #8 private key encoding for this key object

Definition at line 61 of file pk_keys.cpp.

62 {
63 const size_t PKCS8_VERSION = 0;
64
65 return DER_Encoder()
66 .start_cons(SEQUENCE)
67 .encode(PKCS8_VERSION)
68 .encode(pkcs8_algorithm_identifier())
69 .encode(private_key_bits(), OCTET_STRING)
70 .end_cons()
71 .get_contents();
72 }
Botan::Private_Key::pkcs8_algorithm_identifier
virtual AlgorithmIdentifier pkcs8_algorithm_identifier() const
Definition: pk_keys.h:204
Botan::OCTET_STRING
@ OCTET_STRING
Definition: asn1_obj.h:38

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::DER_Encoder::get_contents(), Botan::OCTET_STRING, Botan::Private_Key::pkcs8_algorithm_identifier(), Botan::Private_Key::private_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::PKCS8::BER_encode(), Botan::PKCS8::BER_encode_encrypted_pbkdf_iter(), and Botan::PKCS8::BER_encode_encrypted_pbkdf_msec().

## ◆ public_data()

std::shared_ptr< const RSA_Public_Data > Botan::RSA_PublicKey::public_data | ( |  | ) | const
| inherited

Definition at line 99 of file rsa.cpp.

100 {
101 return m_public;
102 }

References Botan::RSA_PublicKey::m_public.

## ◆ public_key_bits() [1/2]

virtual std::vector< uint8_t > Botan::Public_Key::public_key_bits | ( |  | ) | const
| pure virtual inherited

Returns
  BER encoded public key bits

Implemented in Botan::TPM_PrivateKey, Botan::Curve25519_PublicKey, Botan::DL_Scheme_PublicKey, Botan::EC_PublicKey, Botan::Ed25519_PublicKey, Botan::GOST_3410_PublicKey, Botan::McEliece_PublicKey, Botan::RSA_PublicKey, Botan::XMSS_PublicKey, Botan::XMSS_WOTS_PublicKey, and Botan::XMSS_WOTS_Addressed_PublicKey.

Referenced by Botan::Public_Key::subject_public_key().

## ◆ public_key_bits() [2/2]

std::vector< uint8_t > Botan::RSA_PublicKey::public_key_bits | ( |  | ) | const
| override virtual inherited

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 149 of file rsa.cpp.

150 {
151 std::vector<uint8_t> output;
152 DER_Encoder der(output);
153 der.start_cons(SEQUENCE)
154 .encode(get_n())
155 .encode(get_e())
156 .end_cons();
157
158 return output;
159 }

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::RSA_PublicKey::get_e(), Botan::RSA_PublicKey::get_n(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

## ◆ stateful_operation()

virtual bool Botan::Private_Key::stateful_operation | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::XMSS_PrivateKey.

Definition at line 188 of file pk_keys.h.

188{ return false; }

## ◆ subject_public_key()

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 38 of file pk_keys.cpp.

39 {
40 std::vector<uint8_t> output;
41
42 DER_Encoder(output).start_cons(SEQUENCE)
43 .encode(algorithm_identifier())
44 .encode(public_key_bits(), BIT_STRING)
45 .end_cons();
46
47 return output;
48 }
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::BIT_STRING
@ BIT_STRING
Definition: asn1_obj.h:37

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), Botan::PKCS10_Request::create(), Botan::Public_Key::fingerprint_public(), and Botan::X509::PEM_encode().

## Member Data Documentation

## ◆ m_public

std::shared_ptr<const RSA_Public_Data> Botan::RSA_PublicKey::m_public
| protected inherited

Definition at line 86 of file rsa.h.

Referenced by Botan::RSA_PublicKey::get_e(), Botan::RSA_PublicKey::get_n(), Botan::RSA_PublicKey::init(), Botan::RSA_PublicKey::key_length(), and Botan::RSA_PublicKey::public_data().

The documentation for this class was generated from the following files:

- src/lib/pubkey/rsa/rsa.h
- src/lib/pubkey/rsa/rsa.cpp